PUB null
PUB init(command)

  long[command] := -1
  result := cognew(@rx, command) + 1
  repeat while long[command] AND result

CON
  addr = $1F5   ' outb
  data = $1F7   ' dirb
  zero = $1FF   ' vscl
  
DAT             org     0

rx              wrlong  zero, par               ' active
                call    #receive

receive         mov     data, #0
                waitpne zero, #%000000_11       ' wait for start condition

                test    mask, ina wc            ' hard-wired timing 8 cycles/bit
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1
                test    mask, ina wc
                rcl     data, #1

' post processing
' To reduce overhead this should probably be done in a different cog,
' i.e. just write the byte to hub memory (with a simple marker).
'
'               or      data, #%1_00000000      ' result valid
'               wrlong  data, par
'               ret

                ror     data, #2                ' long index (preserve byte index)
                mov     addr, #grid
                add     addr, data

                movs    $+2, addr               ' prepare table access
                shr     data, #27               ' byte shift
                mov     addr, 0-0               ' access table
                shr     addr, data              ' extract byte
                and     addr, #$FF
                
                or      addr, #%1_00000000      ' result valid
                wrlong  addr, par
receive_ret     ret

mask            long    %000000_01              ' 0-wire

grid            long    $FDFCFEFF, $FBFAF8F9, $F1F0F2F3, $F7F6F4F5
                long    $E5E4E6E7, $E3E2E0E1, $E9E8EAEB, $EFEEECED
                long    $CDCCCECF, $CBCAC8C9, $C1C0C2C3, $C7C6C4C5
                long    $D5D4D6D7, $D3D2D0D1, $D9D8DADB, $DFDEDCDD
                long    $9D9C9E9F, $9B9A9899, $91909293, $97969495
                long    $85848687, $83828081, $89888A8B, $8F8E8C8D
                long    $ADACAEAF, $ABAAA8A9, $A1A0A2A3, $A7A6A4A5
                long    $B5B4B6B7, $B3B2B0B1, $B9B8BABB, $BFBEBCBD
                long    $3D3C3E3F, $3B3A3839, $31303233, $37363435
                long    $25242627, $23222021, $29282A2B, $2F2E2C2D
                long    $0D0C0E0F, $0B0A0809, $01000203, $07060405
                long    $15141617, $13121011, $19181A1B, $1F1E1C1D
                long    $5D5C5E5F, $5B5A5859, $51505253, $57565455
                long    $45444647, $43424041, $49484A4B, $4F4E4C4D
                long    $6D6C6E6F, $6B6A6869, $61606263, $67666465
                long    $75747677, $73727071, $79787A7B, $7F7E7C7D

                fit

DAT