CON
  cmdIDLE = $002  ' idle
  cmdMODE = $007  ' tx_mode
  cmdSEND = $00E  ' tx_send

PUB null
PUB init(command)

  create((cogid+1)&7, command, TRUE)                    ' tx cog one
  create((cogid+3)&7, command, TRUE)                    ' tx cog two
  long[command] := ((cogid+1)&7) << 9 | cmdMODE         ' set primary

PRI create(ID, command, wait)

  long[command] := cmdIDLE & wait
  coginit(ID&7, @tx, command)
  repeat while long[command]
                         
CON
  addr = $1F5   ' outb
  data = $1F7   ' dirb
  zero = $1FF   ' vscl
  
DAT             org     0

tx              jmpret  $, #setup               '  -4

done            wrlong  zero, par               '       transfer done
idle            rdlong  data, par wz            '  +0 = wait for command
        if_nz   jmp     data                    '  +8
                jmp     #idle

this            long    0
exec            long    $003C0000

tx_mode         shr     data, #9                ' +12   parameters
                cmp     data, this wz           ' +16 =
                muxz    primary, exec           ' +20   cogid/nop
                muxnz   secondary, exec         ' +24   nop/xor
                mov     mask, #%01              ' +28   0-wire primary
        if_nz   mov     mask, #%10              ' +32 = 1-wire secondary
                jmp     zero                    ' +36

tx_send         shr     data, #9                ' +12   byte to transfer
primary         cogid   this                    ' +16 =

' At this point both cogs are in sync, the primary comes out of rdlong
' 4 cycles before the secondary. The primary sees cogid(8) while the
' secondary just sees a nop(4).

' The following xor allows us to use the same flag condition for both
' transmitters. It becomes a nop for the primary cog.

secondary       xor     data, #%0_11111111

                test    data, #%0_10000000 wc   ' MSB first
        if_nc   xor     outa, mask
                test    data, #%0_01000000 wc
        if_nc   xor     outa, mask
                test    data, #%0_00100000 wc
        if_nc   xor     outa, mask
                test    data, #%0_00010000 wc
        if_nc   xor     outa, mask
                test    data, #%0_00001000 wc
        if_nc   xor     outa, mask
                test    data, #%0_00000100 wc
        if_nc   xor     outa, mask
                test    data, #%0_00000010 wc
        if_nc   xor     outa, mask
                test    data, #%0_00000001 wc
        if_nc   xor     outa, mask
                nop
                andn    outa, mask              ' back to %00
                jmp     #done

setup           cogid   this                    '  +0 =
                mov     dira, #%11              '  +8   outputs
                jmp     #done                   ' +12

mask            long    %000000_00

                fit

DAT